# CanopyView 2D Plugins - latex.py
# Description: Silhouette plugin.
# Contributors: Nik Molnar
# Created: 2009-06-04
# (c)2009 The Evergreen State College

import math
from PIL import Image
from Plugins import *
from OmniImage import *

#Compass Bitmpa Image
kCompassSize	= (50,50)
kCompassData	= data = '\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xd7\xd7\xd7(\xa3\xa3\xa3\\vvv\x89NNN\xb1---\xd1\x15\x15\x15\xe9\x05\x05\x05\xf9\x05\x05\x05\xf9\x05\x05\x05\xf9\x05\x05\x05\xf9\x15\x15\x15\xe9---\xd1NNN\xb1vvv\x89\xa3\xa3\xa3\\\xd7\xd7\xd7(\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xe2\xe2\xe2\x1c\x98\x98\x98fSSS\xab\x12\x12\x12\xed\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x06\x07\x08\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x12\x12\x12\xedSSS\xab\x98\x98\x98f\xe2\xe2\xe2\x1c\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xde\xde\xde \x87\x87\x87x222\xcd\x00\x00\x00\xff\x00\x00\x00\xff\x06\x06\x07\xff114\xffcei\xff\x89\x8b\x8f\xff\xa9\xab\xb1\xff\xc1\xc3\xcb\xff\xd1\xd4\xdd\xff\xd8\xdb\xe4\xff\xda\xdc\xe5\xff\xcc\xcf\xd6\xff\xbd\xbf\xc7\xff\xa8\xaa\xb1\xff\x8b\x8d\x93\xffdei\xff124\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff222\xcd\x87\x87\x87x\xde\xde\xde \xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x9f\x9f\x9f`===\xc1\x00\x00\x00\xff\x00\x00\x00\xff&&(\xffnpt\xff\xa3\xa6\xad\xff\xcf\xd3\xdc\xff\xdd\xe0\xe8\xff\xde\xe1\xe8\xff\xde\xe1\xe9\xff\xde\xe1\xea\xff\xdb\xde\xe7\xff\xdb\xdf\xe8\xff\xdc\xdf\xe8\xff\xdd\xe0\xe8\xff\xdd\xdf\xe8\xff\xdc\xe0\xe8\xff\xdd\xe0\xe8\xff\xdf\xe1\xe9\xff\xd2\xd5\xdc\xff\xa4\xa6\xad\xfflnr\xff%&(\xff\x00\x00\x00\xff\x00\x00\x00\xff===\xc1\x9f\x9f\x9f`\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xdc\xdc\xdc"ooo\x8f\x04\x04\x04\xfb\x00\x00\x00\xff)*,\xff|~\x82\xff\xbc\xbf\xc7\xff\xde\xe1\xea\xff\xdb\xde\xe7\xff\xdd\xe1\xe9\xff\xdd\xe0\xe8\xff\xdd\xe0\xe8\xff\xdc\xdf\xe7\xff\xde\xe1\xea\xff\xdb\xde\xe7\xff\xdc\xdf\xe8\xff\xdd\xe0\xe8\xff\xdd\xdf\xe8\xff\xdb\xde\xe7\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xde\xe0\xe8\xff\xdf\xe1\xea\xff\xdb\xde\xe6\xff\xdb\xde\xe6\xff\xba\xbd\xc5\xff}\x7f\x84\xff**,\xff\x00\x00\x00\xff\x04\x04\x04\xfbooo\x8f\xdc\xdc\xdc"\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xc4\xc4\xc4:OOO\xaf\x00\x00\x00\xff\x06\x06\x07\xffhim\xff\xb3\xb5\xbc\xff\xda\xdc\xe4\xff\xdb\xdf\xe7\xff\xde\xe1\xea\xff\xdd\xe1\xea\xff\xdb\xdf\xe7\xff\xdb\xde\xe7\xff\xda\xdb\xe4\xff\xdd\xdf\xe7\xff\xdd\xe1\xea\xff\xde\xe2\xeb\xff\x84\x85\x8b\xff\x85\x86\x8b\xff\xd9\xdc\xe4\xff\xd9\xdc\xe4\xff\xdd\xe0\xe8\xff\xe1\xe4\xec\xff\xe0\xe2\xea\xff\xdf\xe2\xea\xff\xdb\xde\xe7\xff\xd8\xda\xe2\xff\xdb\xde\xe6\xff\xde\xe1\xea\xff\xb8\xba\xc1\xffhim\xff\x06\x06\x07\xff\x00\x00\x00\xffOOO\xaf\xc4\xc4\xc4:\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xbd\xbd\xbdB???\xbf\x00\x00\x00\xff+,.\xff\x91\x93\x98\xff\xda\xdd\xe6\xff\xda\xdd\xe6\xff\xda\xdd\xe6\xff\xdc\xdf\xe9\xff\xdb\xdf\xe8\xff\xdd\xe0\xe8\xff\xdd\xe0\xe8\xff\xdd\xe0\xe8\xff\xdd\xdf\xe7\xff\xde\xe1\xe9\xff\xdd\xe0\xe9\xff\x83\x85\x8b\xff\x06\x06\x07\xff\x06\x06\x07\xff\x83\x84\x89\xff\xdd\xdf\xe8\xff\xdd\xe0\xe8\xff\xe0\xe2\xea\xff\xe0\xe2\xe9\xff\xdf\xe1\xe9\xff\xdb\xde\xe6\xff\xda\xdd\xe5\xff\xdd\xe0\xe9\xff\xdd\xe0\xe9\xff\xde\xe1\xe8\xff\xdd\xdf\xe6\xff\x90\x92\x98\xff+,.\xff\x00\x00\x00\xff???\xbf\xbd\xbd\xbdB\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xc4\xc4\xc4:???\xbf\x00\x00\x00\xffDEI\xff\xa8\xaa\xb1\xff\xdf\xe1\xe9\xff\xde\xe1\xea\xff\xdb\xdf\xe8\xff\xda\xdd\xe6\xff\xdb\xdf\xe8\xff\xde\xe1\xea\xff\xdd\xe0\xe8\xff\xdf\xe1\xea\xff\xdc\xdf\xe7\xff\xdb\xdf\xe7\xff\xdb\xde\xe7\xff\x84\x86\x8c\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff\x83\x85\x8a\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xde\xe1\xe8\xff\xdf\xe1\xe9\xff\xdd\xdf\xe7\xff\xdd\xe0\xe8\xff\xdd\xe0\xe9\xff\xdf\xe2\xea\xff\xdf\xe1\xe9\xff\xdf\xe1\xe9\xff\xde\xe1\xe8\xff\xa8\xab\xb1\xffDEG\xff\x00\x00\x00\xff???\xbf\xc4\xc4\xc4:\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xdc\xdc\xdc"OOO\xaf\x00\x00\x00\xffBCF\xff\xb2\xb5\xbd\xff\xe1\xe3\xeb\xff\xdf\xe1\xe9\xff\xdf\xe2\xea\xff\xdb\xde\xe7\xff\xd8\xda\xe3\xff\xdb\xde\xe6\xff\xe1\xe4\xec\xff\xdf\xe2\xea\xff\xdd\xe1\xea\xff\xda\xde\xe7\xff\xd8\xdb\xe4\xff\x82\x83\x88\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x05\x06\xff\x83\x85\x8a\xff\xe1\xe4\xed\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xdd\xe0\xe7\xff\xda\xdc\xe4\xff\xda\xdc\xe5\xff\xdf\xe2\xeb\xff\xe1\xe4\xec\xff\xde\xe1\xe8\xff\xde\xe1\xea\xff\xdb\xdd\xe5\xff\xb1\xb3\xb9\xffDEH\xff\x00\x00\x00\xffOOO\xaf\xdc\xdc\xdc"\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00ooo\x8f\x00\x00\x00\xff++.\xff\xa8\xaa\xb1\xff\xdf\xe1\xe9\xff\xdf\xe2\xea\xff\xe0\xe2\xea\xff\xe0\xe2\xea\xff\xdc\xde\xe7\xff\xdb\xdd\xe6\xff\xde\xe1\xe9\xff\xdf\xe2\xea\xff\xe0\xe3\xea\xff\xe0\xe2\xea\xff\xdd\xe0\xe9\xff\x82\x84\x89\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x06\x06\x07\xff\x85\x87\x8c\xff\xdd\xe0\xe9\xff\xdd\xe0\xe9\xff\xdd\xdf\xe7\xff\xdb\xdd\xe5\xff\xdd\xe0\xe8\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xdd\xdf\xe7\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xa9\xab\xb2\xff,,/\xff\x00\x00\x00\xffooo\x8f\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x9f\x9f\x9f`\x04\x04\x04\xfb\x05\x06\x07\xff\x8f\x91\x97\xff\xdd\xe0\xe8\xff\xe1\xe4\xec\xff\xdf\xe2\xea\xff\xe1\xe3\xea\xff\xdf\xe2\xea\xff\xdc\xdf\xe7\xff\xdc\xdf\xe7\xff\xde\xe1\xe9\xff\xe0\xe3\xeb\xff\xe0\xe2\xea\xff\xe1\xe4\xea\xff\x83\x85\x8a\xff\x05\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x06\x06\x07\xff\x82\x85\x8a\xff\xdc\xdf\xe9\xff\xdd\xdf\xe7\xff\xde\xe0\xe8\xff\xdf\xe1\xea\xff\xe0\xe2\xeb\xff\xde\xe1\xe8\xff\xe0\xe2\xea\xff\xdd\xdf\xe8\xff\xdd\xdf\xe8\xff\xdd\xe0\xe7\xff\xe1\xe4\xec\xff\x91\x93\x99\xff\x06\x06\x07\xff\x04\x04\x04\xfb\x9f\x9f\x9f`\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xde\xde\xde ===\xc1\x00\x00\x00\xffhim\xff\xd7\xd9\xe1\xff\xda\xdc\xe5\xff\xdf\xe1\xea\xff\xe1\xe4\xec\xff\xde\xe0\xe8\xff\xde\xe1\xe9\xff\xdb\xde\xe7\xff\xda\xdd\xe4\xff\xdc\xdf\xe7\xff\xe2\xe5\xec\xff\xe1\xe4\xea\xff\x84\x86\x8b\xff\x05\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff\x84\x86\x8b\xff\xde\xe1\xe8\xff\xda\xdc\xe4\xff\xdb\xde\xe6\xff\xe0\xe3\xeb\xff\xe1\xe4\xeb\xff\xdd\xdf\xe8\xff\xdc\xe0\xe8\xff\xda\xdc\xe4\xff\xdc\xde\xe5\xff\xdf\xe1\xea\xff\xde\xe0\xe9\xffghl\xff\x00\x00\x00\xff===\xc1\xde\xde\xde \xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x87\x87\x87x\x00\x00\x00\xff*+,\xff\xb6\xb8\xbf\xff\xda\xdd\xe5\xff\xdd\xe0\xe8\xff\xe1\xe3\xea\xff\xdf\xe2\xea\xff\xdd\xe0\xe9\xff\xdd\xe1\xe9\xff\xdc\xde\xe6\xff\xdc\xde\xe5\xff\xe0\xe2\xe9\xff\xe1\xe4\xea\xff\x84\x86\x8c\xff\x05\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x06\x06\x07\xff\x82\x84\x89\xff\xd9\xdb\xe3\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xe0\xe2\xea\xff\xde\xe1\xe9\xff\xdc\xde\xe7\xff\xda\xdc\xe5\xff\xdc\xdf\xe7\xff\xdc\xdf\xe8\xff\xde\xe1\xea\xff\xb6\xb8\xc0\xff)*,\xff\x00\x00\x00\xff\x87\x87\x87x\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xe2\xe2\xe2\x1c222\xcd\x00\x00\x00\xff~\x80\x84\xff\xde\xe1\xe8\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xe3\xe5\xec\xff\xdd\xe0\xe7\xff\xdc\xdf\xe8\xff\xdc\xdf\xe8\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xe2\xe4\xeb\xff\x86\x88\x8c\xff\x05\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff\x83\x85\x8a\xff\xdf\xe1\xe9\xff\xe0\xe3\xeb\xff\xdd\xdf\xe7\xff\xdd\xe1\xe9\xff\xdc\xdf\xe8\xff\xde\xe1\xe9\xff\xdd\xe0\xe8\xff\xde\xe2\xeb\xff\xdb\xde\xe7\xff\xdd\xe0\xe9\xff|~\x83\xff\x00\x00\x00\xff222\xcd\xe2\xe2\xe2\x1c\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x98\x98\x98f\x00\x00\x00\xff&\'(\xff\xbf\xc2\xc8\xff\xe1\xe3\xea\xff\xdd\xdf\xe7\xff\xdb\xdd\xe5\xff\xe0\xe2\xea\xff\xe0\xe3\xeb\xff\xdd\xe0\xe9\xff\xdd\xe0\xe8\xff\xde\xe1\xe8\xff\xdd\xdf\xe6\xff\x85\x86\x8b\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff\x84\x85\x8a\xff\xdf\xe2\xea\xff\xdf\xe1\xea\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xdc\xdf\xe7\xff\xda\xdd\xe5\xff\xdd\xe1\xe9\xff\xdf\xe2\xeb\xff\xdd\xe0\xe8\xff\xbb\xbe\xc7\xff$%\'\xff\x00\x00\x00\xff\x98\x98\x98f\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00SSS\xab\x00\x00\x00\xffpqu\xff\xe1\xe3\xea\xff\xe0\xe2\xe9\xff\xd9\xdb\xe4\xff\xda\xdd\xe6\xff\xdc\xdf\xe8\xff\xe0\xe3\xeb\xff\xe0\xe2\xea\xff\xe0\xe2\xea\xff\xdc\xde\xe6\xff\x83\x84\x89\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff\x84\x85\x8b\xff\xe0\xe3\xeb\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xdb\xdd\xe4\xff\xdd\xdf\xe7\xff\xde\xe0\xe8\xff\xe0\xe3\xeb\xff\xdc\xdf\xe8\xff\xdc\xe0\xe8\xfflmr\xff\x00\x00\x00\xffSSS\xab\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xd7\xd7\xd7(\x12\x12\x12\xed\x06\x06\x07\xff\xa6\xa8\xae\xff\xe0\xe3\xea\xff\xde\xe0\xe8\xff\xdd\xe0\xe8\xff\xdd\xdf\xe8\xff\xe0\xe3\xec\xff\xdf\xe1\xe9\xff\xe2\xe4\xea\xff\xdf\xe2\xe9\xff\x84\x86\x8b\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x05\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x07\x08\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x05\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x05\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x84\x86\x8b\xff\xe1\xe3\xeb\xff\xde\xe0\xe8\xff\xdd\xe0\xe8\xff\xde\xe1\xe8\xff\xe3\xe5\xed\xff\xde\xe0\xe9\xff\xdc\xdf\xe9\xff\xdc\xdf\xe8\xff\xa5\xa7\xae\xff\x06\x06\x07\xff\x12\x12\x12\xed\xd7\xd7\xd7(\xff\xff\xff\x00\xff\xff\xff\x00\xa3\xa3\xa3\\\x00\x00\x00\xff235\xff\xd2\xd5\xdc\xff\xe1\xe3\xea\xff\xdf\xe1\xe9\xff\xdd\xdf\xe7\xff\xdb\xde\xe5\xff\xe0\xe3\xeb\xff\xe1\xe3\xea\xff\xe1\xe2\xe9\xff\xe1\xe3\xea\xff\xdd\xe0\xe9\xff\xda\xdc\xe5\xff\xdd\xe1\xe9\xff\xe1\xe4\xeb\xff\xdf\xe2\xe9\xff\xe0\xe2\xea\xff\xde\xe1\xe9\xff\xdd\xdf\xe7\xff\xde\xe0\xe7\xff\xe2\xe5\xec\xff\xe1\xe3\xeb\xff\xe0\xe2\xea\xff\xdf\xe2\xea\xff\xdc\xde\xe7\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xde\xe1\xea\xff\xdd\xe0\xe8\xff\xde\xe1\xe9\xff\xde\xe1\xe8\xff\xdb\xde\xe6\xff\xdd\xe0\xe9\xff\xe0\xe3\xeb\xff\xde\xe1\xe8\xff\xdf\xe1\xe9\xff\xdd\xdf\xe7\xff\xdc\xde\xe7\xff\xdb\xde\xe6\xff\xe1\xe3\xeb\xff\xdd\xe1\xe9\xff\xdb\xdf\xe7\xff\xdd\xe1\xe9\xff\xd1\xd4\xdb\xff113\xff\x00\x00\x00\xff\xa3\xa3\xa3\\\xff\xff\xff\x00\xff\xff\xff\x00vvv\x89\x00\x00\x00\xffefi\xff\xe2\xe4\xec\xff\xdf\xe1\xe9\xff\xde\xe0\xe9\xff\xda\xdb\xe3\xff\xdd\xdf\xe7\xff\xdf\xe1\xe8\xff\xe2\xe5\xec\xff\xdf\xe2\xea\xff\xde\xe1\xe8\xff\xdb\xdd\xe5\xff\xd9\xdb\xe4\xff\xdf\xe1\xe9\xff\xe1\xe3\xeb\xff\xe2\xe4\xec\xff\xdf\xe1\xe9\xff\xdf\xe1\xe9\xff\xda\xdc\xe3\xff\xdc\xde\xe6\xff\xdf\xe1\xe9\xff\xe2\xe5\xed\xff\xdf\xe2\xe9\xff\xde\xe1\xe9\xff\xda\xdc\xe4\xff\xda\xdc\xe4\xff\xdd\xdf\xe8\xff\xdf\xe2\xeb\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdc\xdf\xe7\xff\xd7\xd9\xe2\xff\xdc\xde\xe7\xff\xdf\xe2\xea\xff\xe1\xe4\xec\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xd9\xdb\xe3\xff\xdb\xdd\xe6\xff\xdc\xdf\xe7\xff\xdf\xe3\xeb\xff\xdf\xe1\xea\xff\xde\xe0\xe8\xff\xdb\xdd\xe5\xffbcg\xff\x00\x00\x00\xffvvv\x89\xff\xff\xff\x00\xff\xff\xff\x00NNN\xb1\x00\x00\x00\xff\x8d\x8f\x93\xff\xe0\xe2\xea\xff\xdf\xe2\xe9\xff\xdd\xe0\xe8\xff\xdd\xdf\xe7\xff\xdf\xe1\xe9\xff\xe2\xe5\xec\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xde\xe0\xe8\xff\xdc\xdf\xe7\xff\xdd\xe0\xe8\xff\xe1\xe4\xeb\xff\xe1\xe4\xeb\xff\xdf\xe2\xea\xff\xdf\xe1\xea\xff\xdc\xdf\xe7\xff\xdd\xdf\xe7\xff\xde\xe0\xe9\xff\xdd\xe1\xe8\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xde\xe1\xe8\xff\xdc\xde\xe7\xff\xdd\xdf\xe8\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xdb\xde\xe7\xff\xda\xdd\xe5\xff\xdd\xe0\xe9\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdd\xe0\xe7\xff\xdc\xdf\xe7\xff\xdc\xdf\xe7\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xdb\xde\xe7\xff\x89\x8b\x90\xff\x00\x00\x00\xffNNN\xb1\xff\xff\xff\x00\xff\xff\xff\x00---\xd1\x00\x00\x00\xff\xac\xae\xb4\xff\xe0\xe2\xe9\xff\xdf\xe1\xe9\xff\xde\xe1\xe8\xff\xdf\xe1\xe8\xff\xde\xe1\xe8\xff\xe2\xe5\xed\xff\xe0\xe2\xea\xff\xde\xe1\xe8\xff\xde\xe1\xe8\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xe1\xe3\xec\xff\xdd\xe0\xe8\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xdf\xe1\xe8\xff\xdd\xe0\xe8\xff\xdf\xe2\xeb\xff\xde\xe1\xe8\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xdd\xdf\xe7\xff\xdb\xdd\xe7\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xdd\xe0\xe8\xff\xdf\xe1\xe9\xff\xdd\xe0\xe8\xff\xdc\xdf\xe7\xff\xdd\xdf\xe8\xff\xdf\xe2\xeb\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xde\xe1\xe8\xff\xdc\xdf\xe7\xff\xdb\xde\xe7\xff\xde\xe1\xea\xff\xdf\xe2\xea\xff\xde\xe1\xe8\xff\xdd\xe0\xe8\xff\xdd\xe0\xe9\xff\xa9\xab\xb1\xff\x00\x00\x00\xff---\xd1\xff\xff\xff\x00\xff\xff\xff\x00\x15\x15\x15\xe9\x06\x06\x07\xff\xc2\xc5\xcc\xff\xe3\xe5\xec\xff\xe0\xe3\xea\xff\xe1\xe3\xea\xff\xdb\xdd\xe4\xff\xdd\xde\xe6\xff\xde\xe1\xe9\xff\xe0\xe3\xeb\xff\xdd\xe1\xe8\xff\xe0\xe3\xea\xff\xdd\xdf\xe7\xff\xda\xdd\xe5\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xe0\xe2\xea\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xda\xdd\xe4\xff\xdd\xdf\xe7\xff\xdf\xe1\xe9\xff\xe2\xe4\xec\xff\xdd\xe0\xe8\xff\xdd\xe1\xe8\xff\xda\xdd\xe4\xff\xda\xdd\xe5\xff\xdd\xe0\xe8\xff\xe0\xe3\xeb\xff\xe0\xe2\xea\xff\xdf\xe2\xea\xff\xdc\xdf\xe7\xff\xdb\xdd\xe4\xff\xdc\xdf\xe7\xff\xe0\xe2\xea\xff\xe1\xe3\xeb\xff\xde\xe1\xe9\xff\xdd\xe0\xe9\xff\xd8\xda\xe3\xff\xdb\xdd\xe6\xff\xde\xe1\xe9\xff\xe2\xe4\xec\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdd\xde\xe6\xff\xbe\xc0\xc6\xff\x06\x06\x07\xff\x15\x15\x15\xe9\xff\xff\xff\x00\xff\xff\xff\x00\x05\x05\x05\xf9\x06\x06\x07\xff\xd2\xd4\xdc\xff\xe0\xe2\xe9\xff\xe0\xe2\xea\xff\xde\xe1\xe8\xff\xdd\xdf\xe7\xff\xdf\xe2\xe9\xff\xe1\xe3\xeb\xff\xde\xe1\xe9\xff\xdd\xe1\xe9\xff\xde\xe0\xe8\xff\xde\xe0\xe7\xff\xdd\xe0\xe7\xff\xe0\xe2\xea\xff\xdf\xe2\xea\xff\xdf\xe2\xea\xff\xdf\xe2\xe9\xff\xcf\xd2\xd9\xffXZ\\\xff\xdf\xe1\xe9\xff\xe0\xe2\xe9\xff\xde\xe1\xe9\xff\xdb\xdf\xe7\xff\xde\xe1\xe8\xff\xde\xe1\xe8\xff\xdd\xe0\xe7\xff\xe0\xe2\xea\xff\xe0\xe3\xea\xffhim\xff\xe0\xe2\xea\xff\xdc\xde\xe6\xff\xdd\xdf\xe6\xff\xe0\xe3\xea\xff\xe2\xe4\xeb\xff\xdd\xe0\xe8\xff\xdd\xe0\xe8\xff\xde\xe1\xe8\xff\xdd\xdf\xe7\xff\xe0\xe2\xea\xff\xe3\xe5\xec\xff\xe0\xe2\xea\xff\xdf\xe2\xe9\xff\xdf\xe2\xe9\xff\xdd\xdf\xe7\xff\xcf\xd2\xd9\xff\x06\x07\x07\xff\x05\x05\x05\xf9\xff\xff\xff\x00\xff\xff\xff\x00\x05\x05\x05\xf9\x06\x06\x07\xff\xdd\xe0\xe8\xff\xdf\xe1\xe9\xff\xe0\xe3\xea\xff\xdf\xe1\xe9\xff\xdf\xe1\xe8\xff\xdd\xe0\xe7\xff\xe2\xe5\xed\xff\xdf\xe1\xe9\xff\xdf\xe1\xea\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xdc\xde\xe7\xff\xdf\xe1\xea\xff\xe0\xe3\xeb\xff\xdd\xe0\xe7\xff\xcf\xd2\xda\xff;<>\xff\x00\x00\x00\xff\x85\x87\x8b\xff\xe0\xe2\xea\xff\xdd\xe0\xe9\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xdc\xdf\xe7\xff\xdf\xe1\xe9\xff\x1e\x1e\x1f\xff\x00\x00\x00\xff\xe0\xe3\xea\xff\xdd\xe0\xe8\xff\xdc\xdf\xe7\xff\xdf\xe2\xe9\xff\xe2\xe4\xeb\xff\xde\xe1\xe9\xff\xdf\xe2\xea\xff\xdd\xe0\xe8\xff\xdd\xe0\xe7\xff\xdd\xe0\xe7\xff\xe3\xe5\xed\xff\xdf\xe1\xe9\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xde\xe0\xe8\xff\xdb\xde\xe5\xff\x06\x06\x07\xff\x05\x05\x05\xf9\xff\xff\xff\x00\xff\xff\xff\x00\x05\x05\x05\xf9\x05\x06\x07\xff\xdc\xdf\xe6\xff\xe2\xe4\xec\xff\xe0\xe2\xea\xff\xe1\xe3\xea\xff\xdb\xdd\xe5\xff\xdb\xdd\xe4\xff\xdf\xe1\xe8\xff\xe2\xe4\xec\xff\xde\xe1\xe8\xff\xe0\xe2\xea\xff\xdd\xdf\xe7\xff\xd8\xdb\xe3\xff\xdc\xde\xe6\xff\xe1\xe4\xec\xff\xe0\xe2\xea\xff\xb2\xb4\xba\xff\x0f\x0f\x10\xff\x00\x00\x00\xff\x1d\x1d\x1f\xff\xcf\xd2\xd9\xff\xe0\xe3\xec\xff\xdd\xe0\xe8\xff\xde\xe1\xe9\xff\xda\xdd\xe5\xff\xd9\xdb\xe4\xff\xdd\xdf\xe7\xffyz~\xff\x00\x00\x00\xff\xdf\xe2\xea\xff\xde\xe1\xe8\xff\xda\xdc\xe4\xff\xdc\xde\xe5\xff\xe0\xe3\xea\xff\xe0\xe3\xeb\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xda\xdc\xe4\xff\xd9\xdb\xe4\xff\xde\xe1\xe8\xff\xe2\xe5\xec\xff\xdd\xe0\xe8\xff\xe0\xe2\xea\xff\xde\xe1\xe8\xff\xd6\xd9\xe0\xff\x06\x06\x07\xff\x05\x05\x05\xf9\xff\xff\xff\x00\xff\xff\xff\x00\x05\x05\x05\xf9\x06\x06\x07\xff\xd1\xd3\xdc\xff\xdf\xe2\xea\xff\xdd\xe0\xe8\xff\xdd\xe0\xe7\xff\xdc\xde\xe5\xff\xdd\xe0\xe7\xff\xe0\xe2\xea\xff\xe1\xe3\xea\xff\xe1\xe4\xea\xff\xe0\xe2\xea\xff\xdb\xdd\xe6\xff\xd9\xdc\xe4\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xe1\xe4\xea\xff\xe0\xe2\xe9\xff;<>\xff\x00\x00\x00\xff\x00\x00\x00\xffhim\xff\xde\xe2\xea\xff\xdc\xdf\xe8\xff\xdd\xe0\xe8\xff\xda\xdd\xe6\xff\xdc\xde\xe7\xff\xde\xe1\xe9\xff\xc2\xc4\xcb\xff\x00\x00\x00\xff\xe0\xe2\xea\xff\xdd\xdf\xe7\xff\xdc\xde\xe6\xff\xde\xe1\xe8\xff\xdf\xe2\xea\xff\xe1\xe3\xea\xff\xe0\xe2\xea\xff\xdc\xdf\xe7\xff\xda\xdd\xe5\xff\xdd\xdf\xe7\xff\xe0\xe3\xea\xff\xdf\xe2\xea\xff\xdc\xe0\xe8\xff\xdd\xe0\xe9\xff\xdd\xdf\xe7\xff\xce\xd0\xd7\xff\x06\x06\x07\xff\x05\x05\x05\xf9\xff\xff\xff\x00\xff\xff\xff\x00\x15\x15\x15\xe9\x06\x06\x07\xff\xc2\xc5\xcc\xff\xdc\xdf\xe7\xff\xdd\xe1\xe9\xff\xde\xe0\xe9\xff\xde\xe0\xe8\xff\xdd\xe0\xe7\xff\xe3\xe5\xed\xff\xe0\xe2\xea\xff\xe1\xe4\xeb\xff\xe0\xe3\xea\xff\xdd\xe1\xe8\xff\xdd\xdf\xe7\xff\xdd\xe1\xe9\xff\xe0\xe3\xeb\xff\xe1\xe3\xea\xff\xe1\xe4\xea\xff;<>\xffXY\\\xffIJM\xff\x00\x00\x00\xff\xbf\xc1\xc8\xff\xdc\xe0\xe9\xff\xdd\xe0\xe8\xff\xdd\xdf\xe7\xff\xde\xe0\xe8\xff\xdf\xe2\xea\xff\xa4\xa6\xac\xff\x00\x00\x00\xff\xe0\xe3\xea\xff\xde\xe1\xe8\xff\xdd\xdf\xe7\xff\xe0\xe2\xea\xff\xe2\xe4\xec\xff\xdf\xe1\xe8\xff\xe0\xe2\xea\xff\xdf\xe0\xe8\xff\xde\xe1\xe8\xff\xde\xe0\xe8\xff\xe3\xe5\xed\xff\xdd\xe1\xe9\xff\xdc\xe0\xe9\xff\xdd\xdf\xe8\xff\xdf\xe1\xe9\xff\xc0\xc2\xc9\xff\x06\x06\x07\xff\x15\x15\x15\xe9\xff\xff\xff\x00\xff\xff\xff\x00---\xd1\x00\x00\x00\xff\xa9\xac\xb3\xff\xde\xe1\xea\xff\xdd\xe0\xe9\xff\xde\xe1\xe9\xff\xdb\xdd\xe5\xff\xdd\xdf\xe7\xff\xdf\xe2\xe9\xff\xe2\xe5\xec\xff\xe0\xe2\xea\xff\xe0\xe2\xea\xff\xdd\xe0\xe7\xff\xdb\xdd\xe5\xff\xdb\xde\xe7\xff\xe1\xe4\xeb\xff\xe2\xe4\xeb\xff\xe0\xe2\xea\xff;<>\xffuvz\xff\xce\xd0\xd8\xff\x1e\x1e\x1f\xffXZ^\xff\xdc\xdf\xe7\xff\xe0\xe2\xea\xff\xdc\xde\xe6\xff\xdd\xdf\xe7\xff\xde\xe1\xe8\xff\xa6\xa8\xad\xff\x0f\x0f\x10\xff\xdf\xe2\xea\xff\xdd\xe0\xe8\xff\xdb\xdd\xe4\xff\xdd\xe0\xe7\xff\xe2\xe4\xeb\xff\xe3\xe5\xec\xff\xe0\xe2\xe9\xff\xe0\xe3\xea\xff\xdb\xdd\xe5\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xdf\xe2\xeb\xff\xdd\xe0\xe9\xff\xde\xe1\xe9\xff\xde\xe0\xe8\xff\xa6\xa8\xae\xff\x00\x00\x00\xff---\xd1\xff\xff\xff\x00\xff\xff\xff\x00NNN\xb1\x00\x00\x00\xff\x8b\x8d\x92\xff\xdf\xe2\xea\xff\xde\xe1\xea\xff\xde\xe1\xe8\xff\xdd\xdf\xe6\xff\xdf\xe1\xe8\xff\xe1\xe2\xe9\xff\xe0\xe3\xea\xff\xde\xe1\xea\xff\xdd\xe1\xe9\xff\xdb\xdd\xe6\xff\xd9\xdc\xe4\xff\xdc\xdf\xe8\xff\xdf\xe2\xea\xff\xdf\xe2\xea\xff\xde\xe1\xe9\xffYZ]\xffuvz\xff\xde\xe0\xe7\xff\xb2\xb4\xba\xff\x0f\x0f\x10\xff\x85\x87\x8c\xff\xdf\xe1\xe9\xff\xdd\xde\xe6\xff\xde\xe0\xe7\xff\xe0\xe2\xe9\xff\xb4\xb6\xbc\xff\x00\x00\x00\xff\xde\xe1\xe9\xff\xda\xdc\xe5\xff\xd9\xdc\xe4\xff\xdd\xe1\xe9\xff\xdf\xe2\xea\xff\xe2\xe4\xeb\xff\xe1\xe4\xeb\xff\xde\xe1\xe9\xff\xd9\xdc\xe4\xff\xdb\xde\xe7\xff\xdc\xdf\xe8\xff\xdc\xe0\xe9\xff\xdd\xe1\xea\xff\xdd\xe0\xe8\xff\xda\xdd\xe6\xff\x88\x8a\x90\xff\x00\x00\x00\xffNNN\xb1\xff\xff\xff\x00\xff\xff\xff\x00vvv\x89\x00\x00\x00\xffefj\xff\xdd\xe0\xe8\xff\xe0\xe2\xea\xff\xde\xe0\xe8\xff\xe0\xe2\xe9\xff\xe0\xe2\xe9\xff\xe4\xe6\xed\xff\xdd\xdf\xe7\xff\xdb\xde\xe7\xff\xdc\xdf\xe8\xff\xde\xe1\xe9\xff\xde\xe1\xe8\xff\xdf\xe1\xea\xff\xde\xe1\xea\xff\xdb\xde\xe7\xff\xde\xe1\xe9\xffhil\xff\x94\x96\x9b\xff\xdd\xdf\xe8\xff\xe1\xe3\xeb\xff\x85\x86\x8b\xff\x0f\x0f\x10\xff\xb1\xb3\xba\xff\xde\xe1\xe8\xff\xde\xe1\xe8\xff\xe2\xe4\xec\xff\xe0\xe3\xea\xff\x00\x00\x00\xff\xde\xe1\xe9\xff\xdc\xde\xe7\xff\xdd\xe0\xe8\xff\xde\xe1\xe9\xff\xdf\xe1\xea\xff\xdd\xe0\xe7\xff\xe1\xe3\xea\xff\xde\xe0\xe8\xff\xdd\xe0\xe8\xff\xdc\xdf\xe8\xff\xde\xe2\xeb\xff\xda\xdd\xe6\xff\xdc\xdf\xe7\xff\xdd\xe0\xe8\xff\xdc\xdf\xe7\xffcdi\xff\x00\x00\x00\xffvvv\x89\xff\xff\xff\x00\xff\xff\xff\x00\xa3\xa3\xa3\\\x00\x00\x00\xff225\xff\xd4\xd6\xde\xff\xe0\xe3\xeb\xff\xe1\xe3\xea\xff\xde\xe0\xe7\xff\xdb\xdd\xe5\xff\xdf\xe1\xe9\xff\xdd\xe1\xea\xff\xdc\xdf\xe8\xff\xde\xe1\xe8\xff\xdf\xe1\xe8\xff\xdd\xdf\xe6\xff\xdd\xdf\xe7\xff\xdf\xe1\xea\xff\xde\xe1\xea\xff\xde\xe1\xea\xff;<>\xff\xae\xb0\xb7\xff\xdb\xde\xe7\xff\xe0\xe3\xea\xff\xdf\xe2\xea\xff--/\xff--/\xff\xdd\xe0\xe7\xff\xdd\xdf\xe7\xff\xdf\xe1\xe9\xff\xe0\xe2\xea\xff\x0f\x0f\x10\xff\xe1\xe4\xeb\xff\xdf\xe1\xe9\xff\xdd\xdf\xe6\xff\xdc\xdf\xe7\xff\xde\xe1\xe9\xff\xdf\xe2\xea\xff\xe0\xe3\xea\xff\xde\xe1\xe9\xff\xdb\xde\xe7\xff\xdb\xdd\xe5\xff\xdd\xe1\xe9\xff\xdd\xe1\xea\xff\xdc\xdf\xe8\xff\xde\xe1\xe9\xff\xcf\xd2\xdb\xff013\xff\x00\x00\x00\xff\xa3\xa3\xa3\\\xff\xff\xff\x00\xff\xff\xff\x00\xd7\xd7\xd7(\x12\x12\x12\xed\x06\x06\x07\xff\xa7\xa9\xb0\xff\xdd\xe0\xe8\xff\xdf\xe1\xe9\xff\xda\xdc\xe4\xff\xdb\xdd\xe6\xff\xdc\xdf\xe7\xff\xde\xe1\xea\xff\xdd\xe0\xe8\xff\xe0\xe2\xea\xff\xdd\xdf\xe7\xff\xda\xdd\xe5\xff\xdd\xdf\xe8\xff\xde\xe1\xe9\xff\xdf\xe2\xea\xff\xdd\xdf\xe7\xffIJM\xff\xa0\xa2\xa7\xff\xdd\xdf\xe7\xff\xde\xe1\xe8\xff\xdf\xe2\xeb\xff\xc0\xc3\xca\xff;<>\xffghk\xff\xdd\xde\xe5\xff\xde\xe0\xe8\xff\xb4\xb6\xbb\xff--/\xff\xe0\xe2\xea\xff\xdc\xdf\xe7\xff\xd9\xdc\xe4\xff\xda\xdd\xe6\xff\xdc\xdf\xe8\xff\xdf\xe2\xea\xff\xdd\xe0\xe8\xff\xdd\xdf\xe8\xff\xda\xdc\xe4\xff\xdb\xde\xe7\xff\xda\xde\xe7\xff\xdd\xe1\xea\xff\xdb\xde\xe7\xff\xdd\xe0\xe9\xff\xa4\xa6\xac\xff\x05\x05\x07\xff\x12\x12\x12\xed\xd7\xd7\xd7(\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00SSS\xab\x00\x00\x00\xfflns\xff\xdc\xe0\xe9\xff\xdd\xdf\xe7\xff\xdd\xe0\xe8\xff\xdb\xdf\xe7\xff\xdf\xe3\xeb\xff\xdc\xdf\xe8\xff\xdc\xe0\xe8\xff\xdc\xdf\xe8\xff\xdc\xdf\xe8\xff\xdc\xdf\xe7\xff\xde\xe1\xea\xff\xdf\xe2\xea\xff\xde\xe0\xe7\xff\xe0\xe2\xea\xff;<>\xff\xa3\xa4\xaa\xff\xdf\xe1\xe9\xff\xe2\xe4\xec\xff\xdc\xdf\xe7\xff\xdc\xdf\xe7\xff\xa2\xa4\xaa\xff\x00\x00\x00\xff\xa4\xa5\xab\xff\xe1\xe4\xeb\xff\xa4\xa6\xab\xff,-.\xff\xde\xe1\xe9\xff\xdc\xdf\xe7\xff\xdc\xdf\xe7\xff\xdd\xe0\xe9\xff\xdd\xe0\xe9\xff\xdb\xde\xe7\xff\xdd\xe1\xe9\xff\xdc\xdf\xe7\xff\xdc\xdf\xe7\xff\xdb\xde\xe7\xff\xdd\xe1\xeb\xff\xdb\xde\xe8\xff\xdc\xdf\xe8\xff\xdd\xe0\xe8\xffmos\xff\x00\x00\x00\xffSSS\xab\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x98\x98\x98f\x00\x00\x00\xff%%\'\xff\xbc\xbf\xc7\xff\xdf\xe1\xe9\xff\xdc\xde\xe7\xff\xd9\xdc\xe5\xff\xde\xe1\xea\xff\xdd\xe0\xe9\xff\xdb\xdf\xe7\xff\xdd\xe1\xe9\xff\xdd\xe0\xe8\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xe2\xe4\xec\xff\xe1\xe2\xea\xff\xe1\xe3\xeb\xffXZ]\xff\xa1\xa3\xa9\xff\xdd\xdf\xe7\xff\xe1\xe4\xec\xff\xde\xe2\xea\xff\xdd\xe1\xe9\xff\xe0\xe3\xea\xffYZ\\\xffIJM\xff\xd1\xd3\xda\xff\xa4\xa6\xac\xff;<>\xff\xdf\xe1\xea\xff\xdf\xe1\xe8\xff\xdd\xdf\xe6\xff\xdd\xe0\xe9\xff\xdd\xe1\xea\xff\xdb\xde\xe7\xff\xdc\xdf\xe8\xff\xdb\xde\xe7\xff\xda\xdd\xe6\xff\xd9\xdc\xe5\xff\xdd\xe0\xea\xff\xdc\xe0\xe9\xff\xdb\xde\xe7\xff\xbb\xbe\xc6\xff%%\'\xff\x00\x00\x00\xff\x98\x98\x98f\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xe2\xe2\xe2\x1c222\xcd\x00\x00\x00\xff|~\x83\xff\xde\xe1\xe9\xff\xd8\xda\xe3\xff\xdb\xdd\xe6\xff\xdd\xdf\xe8\xff\xe0\xe3\xeb\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xdb\xdd\xe5\xff\xda\xdc\xe4\xff\xdd\xe1\xe8\xff\xe1\xe3\xea\xff\xe2\xe4\xec\xff\xdd\xe0\xe8\xff;<>\xff\xa0\xa1\xa6\xff\xdd\xdf\xe6\xff\xdf\xe1\xea\xff\xe1\xe4\xec\xff\xdf\xe2\xea\xff\xdf\xe2\xea\xff\xd9\xdc\xe4\xffHIL\xff;<>\xff\xa5\xa7\xad\xff<=>\xff\xe1\xe3\xea\xff\xdd\xe0\xe7\xff\xd7\xd9\xe2\xff\xda\xdd\xe7\xff\xdc\xdf\xe9\xff\xdf\xe3\xeb\xff\xdd\xe0\xe8\xff\xdc\xdf\xe8\xff\xd8\xda\xe3\xff\xda\xdd\xe5\xff\xda\xdd\xe6\xff\xde\xe1\xea\xff\xdd\xe0\xe9\xff{}\x82\xff\x00\x00\x00\xff222\xcd\xe2\xe2\xe2\x1c\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x87\x87\x87x\x00\x00\x00\xff)*,\xff\xb5\xb7\xbe\xff\xdc\xdf\xe7\xff\xdd\xe0\xe8\xff\xe1\xe3\xeb\xff\xdf\xe1\xe9\xff\xe1\xe3\xea\xff\xdf\xe1\xe9\xff\xdc\xde\xe7\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xdf\xe1\xea\xff\xde\xe1\xe9\xff\xde\xe1\xea\xff,-.\xffvw|\xff\xdf\xe2\xe9\xff\xdf\xe2\xe9\xff\xe0\xe2\xe9\xff\xe1\xe4\xea\xff\xde\xe1\xe9\xff\xdb\xdd\xe6\xff\xa2\xa4\xaa\xff\x00\x00\x00\xff\x0f\x0f\x10\xff\x00\x00\x00\xff\xde\xe1\xe9\xff\xdb\xde\xe7\xff\xd9\xdc\xe5\xff\xdb\xdf\xe8\xff\xdc\xe0\xe9\xff\xdf\xe1\xe9\xff\xdf\xe2\xea\xff\xdc\xde\xe7\xff\xda\xdd\xe6\xff\xda\xde\xe7\xff\xdd\xe1\xea\xff\xdc\xdf\xe8\xff\xb5\xb8\xbf\xff)*,\xff\x00\x00\x00\xff\x87\x87\x87x\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xde\xde\xde ===\xc1\x00\x00\x00\xfffhl\xff\xd8\xdb\xe4\xff\xda\xdd\xe7\xff\xe1\xe4\xec\xff\xe0\xe3\xea\xff\xdf\xe1\xe8\xff\xdf\xe1\xe9\xff\xe0\xe2\xe9\xff\xdf\xe2\xe9\xff\xde\xe1\xe9\xff\xe0\xe3\xeb\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\x1e\x1e\x1f\xff\x84\x86\x8b\xff\xdd\xe0\xe8\xff\xe1\xe4\xeb\xff\xdf\xe1\xe9\xff\xe0\xe2\xe9\xff\xe0\xe2\xe9\xff\xde\xe0\xe8\xff\xdc\xdf\xe7\xffXZ]\xff\x00\x00\x00\xff\x1d\x1e\x1f\xff\xde\xe1\xe9\xff\xdc\xdf\xe7\xff\xda\xdd\xe6\xff\xda\xdd\xe7\xff\xde\xe1\xea\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xdc\xdf\xe7\xff\xda\xdd\xe7\xff\xda\xdd\xe6\xff\xdd\xe1\xea\xff\xdb\xde\xe6\xffghl\xff\x00\x00\x00\xff===\xc1\xde\xde\xde \xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x9f\x9f\x9f`\x04\x04\x04\xfb\x05\x06\x07\xff\x8b\x8d\x93\xff\xd9\xdc\xe5\xff\xde\xe0\xe8\xff\xe1\xe4\xec\xff\xde\xe1\xe9\xff\xe1\xe3\xeb\xff\xde\xe0\xe7\xff\xdc\xde\xe6\xff\xde\xe0\xe8\xff\xe0\xe2\xea\xff\xdf\xe2\xea\xff\xc0\xc2\xc9\xff\x0f\x0f\x0f\xff\xbd\xbf\xc6\xff\xdd\xdf\xe7\xff\xe0\xe2\xea\xff\xe2\xe5\xec\xff\xdf\xe1\xe9\xff\xdf\xe1\xe9\xff\xda\xdc\xe4\xff\xd9\xdc\xe4\xff\xdb\xde\xe7\xff--/\xff\x94\x96\x9c\xff\xdf\xe2\xea\xff\xdc\xdf\xe7\xff\xd8\xda\xe3\xff\xda\xdd\xe6\xff\xdf\xe2\xea\xff\xe1\xe4\xeb\xff\xde\xe1\xe9\xff\xdd\xe0\xe8\xff\xd8\xda\xe3\xff\xda\xdd\xe5\xff\xdd\xe0\xe8\xff\x92\x94\x9a\xff\x06\x06\x07\xff\x04\x04\x04\xfb\x9f\x9f\x9f`\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00ooo\x8f\x00\x00\x00\xff+,.\xff\xa9\xab\xb1\xff\xe1\xe4\xeb\xff\xde\xe1\xe9\xff\xdd\xe0\xe9\xff\xdd\xe0\xe8\xff\xde\xe1\xe8\xff\xde\xe0\xe8\xff\xe1\xe3\xea\xff\xe0\xe3\xea\xff\xdd\xe0\xe9\xff\xce\xd1\xd9\xff\xc0\xc2\xc8\xff\xde\xe0\xe8\xff\xdf\xe1\xe9\xff\xdf\xe2\xe9\xff\xdf\xe2\xea\xff\xde\xe1\xe8\xff\xde\xe0\xe8\xff\xdb\xde\xe7\xff\xdc\xde\xe7\xff\xdf\xe2\xea\xff\xd0\xd3\xda\xff\xdd\xe0\xe8\xff\xde\xe1\xe9\xff\xdc\xde\xe6\xff\xda\xdd\xe5\xff\xdf\xe2\xea\xff\xe1\xe3\xeb\xff\xdf\xe1\xe9\xff\xe0\xe2\xea\xff\xdf\xe1\xe9\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xab\xad\xb3\xff,,/\xff\x00\x00\x00\xffooo\x8f\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xdc\xdc\xdc"OOO\xaf\x00\x00\x00\xffDEG\xff\xb6\xb9\xc0\xff\xdd\xe0\xe9\xff\xde\xe1\xe9\xff\xdd\xe0\xe9\xff\xdd\xe0\xe8\xff\xdd\xdf\xe7\xff\xe1\xe3\xea\xff\xe1\xe4\xeb\xff\xdc\xde\xe7\xff\xdd\xe1\xe9\xff\xde\xe1\xe8\xff\xdf\xe1\xe9\xff\xdd\xe0\xe8\xff\xdf\xe1\xea\xff\xde\xe1\xe9\xff\xe0\xe2\xea\xff\xdd\xe1\xe9\xff\xdc\xdf\xe8\xff\xdb\xde\xe7\xff\xdf\xe1\xea\xff\xdf\xe2\xea\xff\xdd\xe0\xe8\xff\xde\xe1\xea\xff\xdd\xe0\xe8\xff\xdc\xde\xe7\xff\xde\xe1\xe9\xff\xe1\xe4\xeb\xff\xe1\xe3\xea\xff\xe1\xe3\xeb\xff\xdd\xe0\xe8\xff\xdc\xdf\xe7\xff\xb2\xb5\xbc\xffEFI\xff\x00\x00\x00\xffOOO\xaf\xdc\xdc\xdc"\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xc4\xc4\xc4:???\xbf\x00\x00\x00\xffDEG\xff\xab\xad\xb3\xff\xdd\xdf\xe7\xff\xdf\xe2\xea\xff\xdd\xdf\xe7\xff\xdb\xdd\xe4\xff\xde\xe0\xe7\xff\xe1\xe4\xeb\xff\xde\xe1\xea\xff\xdd\xe0\xe9\xff\xdf\xe1\xe9\xff\xda\xdd\xe4\xff\xda\xdc\xe4\xff\xdd\xe1\xe8\xff\xe1\xe4\xec\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xda\xdc\xe4\xff\xd9\xdb\xe4\xff\xdd\xdf\xe7\xff\xe1\xe3\xeb\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xde\xe1\xe8\xff\xd8\xdb\xe3\xff\xd9\xdc\xe4\xff\xe1\xe3\xea\xff\xe2\xe4\xec\xff\xdf\xe1\xea\xff\xde\xe1\xe9\xff\xa5\xa7\xae\xffBCF\xff\x00\x00\x00\xff???\xbf\xc4\xc4\xc4:\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xbd\xbd\xbdB???\xbf\x00\x00\x00\xff,-/\xff\x91\x93\x98\xff\xdc\xde\xe7\xff\xdc\xdf\xe7\xff\xdc\xde\xe6\xff\xde\xe1\xe9\xff\xe0\xe2\xeb\xff\xdd\xe1\xe9\xff\xdc\xdf\xe8\xff\xdc\xdf\xe7\xff\xda\xdc\xe4\xff\xdc\xdf\xe7\xff\xdd\xe1\xe9\xff\xe0\xe3\xeb\xff\xe1\xe3\xea\xff\xe0\xe2\xe9\xff\xdc\xde\xe6\xff\xdd\xe0\xe7\xff\xe0\xe2\xea\xff\xe1\xe3\xea\xff\xdf\xe2\xea\xff\xde\xe1\xe9\xff\xdb\xde\xe6\xff\xda\xdd\xe5\xff\xde\xe0\xe8\xff\xe0\xe2\xea\xff\xde\xe1\xea\xff\xd9\xdc\xe5\xff\x8e\x90\x96\xff++.\xff\x00\x00\x00\xff???\xbf\xbd\xbd\xbdB\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xc4\xc4\xc4:OOO\xaf\x00\x00\x00\xff\x06\x06\x07\xffhim\xff\xb5\xb7\xbe\xff\xdc\xdf\xe7\xff\xde\xe1\xe9\xff\xdf\xe3\xeb\xff\xdc\xdf\xe8\xff\xdd\xe0\xe9\xff\xdd\xdf\xe8\xff\xdd\xe0\xe8\xff\xdd\xe0\xe7\xff\xe0\xe3\xeb\xff\xdf\xe1\xe9\xff\xe2\xe4\xeb\xff\xe0\xe2\xea\xff\xdc\xdf\xe7\xff\xdd\xdf\xe7\xff\xe1\xe3\xeb\xff\xe1\xe3\xea\xff\xde\xe1\xe9\xff\xde\xe1\xe9\xff\xde\xe1\xe8\xff\xde\xe0\xe8\xff\xe0\xe3\xea\xff\xe1\xe4\xec\xff\xb2\xb5\xbd\xfffhl\xff\x05\x06\x07\xff\x00\x00\x00\xffOOO\xaf\xc4\xc4\xc4:\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xdc\xdc\xdc"ooo\x8f\x04\x04\x04\xfb\x00\x00\x00\xff)),\xffz|\x80\xff\xba\xbd\xc4\xff\xde\xe1\xea\xff\xdd\xe1\xe9\xff\xde\xe1\xe9\xff\xdf\xe1\xe9\xff\xdb\xdd\xe6\xff\xdd\xdf\xe7\xff\xe0\xe3\xea\xff\xe2\xe5\xeb\xff\xdf\xe1\xe9\xff\xde\xe1\xe9\xff\xda\xdc\xe5\xff\xdb\xdd\xe6\xff\xde\xe1\xe8\xff\xe1\xe4\xec\xff\xde\xe0\xe8\xff\xe1\xe3\xea\xff\xe0\xe2\xe9\xff\xdc\xdd\xe5\xff\xbb\xbd\xc5\xff}\x7f\x84\xff)*,\xff\x00\x00\x00\xff\x04\x04\x04\xfbooo\x8f\xdc\xdc\xdc"\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\x9f\x9f\x9f`===\xc1\x00\x00\x00\xff\x00\x00\x00\xff%&(\xffnpt\xff\xa6\xa8\xaf\xff\xd2\xd5\xdd\xff\xde\xe0\xe7\xff\xda\xdd\xe4\xff\xde\xe0\xe7\xff\xe0\xe2\xe9\xff\xe1\xe4\xeb\xff\xde\xe1\xe9\xff\xdc\xdf\xe8\xff\xda\xdc\xe4\xff\xdb\xdd\xe6\xff\xdd\xe0\xe8\xff\xdf\xe2\xea\xff\xe1\xe3\xea\xff\xd5\xd6\xde\xff\xa5\xa7\xac\xfflmq\xff%&(\xff\x00\x00\x00\xff\x00\x00\x00\xff===\xc1\x9f\x9f\x9f`\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xde\xde\xde \x87\x87\x87x222\xcd\x00\x00\x00\xff\x00\x00\x00\xff\x05\x06\x07\xff124\xffdei\xff\x8b\x8d\x92\xff\xaa\xac\xb2\xff\xc3\xc5\xcd\xff\xce\xd1\xd9\xff\xdb\xde\xe6\xff\xd9\xdc\xe4\xff\xcf\xd1\xd9\xff\xbf\xc1\xc9\xff\xa9\xac\xb3\xff\x8b\x8d\x92\xffefi\xff235\xff\x06\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff222\xcd\x87\x87\x87x\xde\xde\xde \xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xe2\xe2\xe2\x1c\x98\x98\x98fSSS\xab\x12\x12\x12\xed\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x06\x06\x07\xff\x05\x06\x07\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x00\x00\x00\xff\x12\x12\x12\xedSSS\xab\x98\x98\x98f\xe2\xe2\xe2\x1c\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xd7\xd7\xd7(\xa3\xa3\xa3\\vvv\x89NNN\xb1---\xd1\x15\x15\x15\xe9\x05\x05\x05\xf9\x05\x05\x05\xf9\x05\x05\x05\xf9\x05\x05\x05\xf9\x15\x15\x15\xe9---\xd1NNN\xb1vvv\x89\xa3\xa3\xa3\\\xd7\xd7\xd7(\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00\xff\xff\xff\x00'

#Hard-coded options
kPixelsToMeter		= 10 #Number of pixels in one meter
kCellSize			= 50 #Size of one grid square in pixels
kMaxDistance		= 10 #Maximum distance to connect two branches (in pixels)
kMinBranchLength	= 1 #Minimum length a branch must be to be drawn (in pixels)
kBaseImageSize		= (300,875) #Should be changed later to take user-input or use the largest tree in the dataset.

kSideNorth		= 0
kSideEast		= 1
kSideSouthEast	= 2
kSideNorthEast	= 3

kLabelsTable = {
	kSideNorth		: "<- W [Looking North] E ->",
	kSideEast		: "<- N [Looking East] S ->",
	kSideSouthEast	: "<- NE [Looking South-East] SW ->",
	kSideNorthEast	: "<- NW [Looking North-East] SE ->"
}

kSideAzimuths = {
	kSideNorth		: (270, 90),
	kSideEast		: (0, 180),
	kSideSouthEast	: (45, 255),
	kSideNorthEast	: (315, 135)
}

def init():
	return LatexPlugin()
	
class LatexPlugin:
	"Latex plugin class."
	
	def __init__(self):
		"Constructor."
		
		self.dataset		= None
		self.datasetHash	= None
		self.stemsById		= { }
		
		#Compass Images
		self.compassNorth		= Image.fromstring('RGBA', kCompassSize, kCompassData)
		self.compassEast		= self.compassNorth.rotate(90)
		self.compassSouthEast	= self.compassNorth.rotate(135)
		self.compassNorthEast	= self.compassNorth.rotate(45)
		
		
	def GetStem(self, dataset, siteId, stemId):
		"Internal method. Get a single tree and associated branches for the given dataset."
		
		#Resolve column and table names
		nameStem		= dataset.MapTable("stem")
		nameBranch		= dataset.MapTable("branch")
		nameSiteid		= dataset.MapColumn("site_id")
		nameStemid		= dataset.MapColumn("stem_id")
		nameDbh			= dataset.MapColumn("dbh")
		nameLivestatus	= dataset.MapColumn("live_status")
		nameHeight		= dataset.MapColumn("height")
		nameBranchdata	= dataset.MapColumn("branch_data?")
		nameBranchid	= dataset.MapColumn("branch_id")
		nameDiameter	= dataset.MapColumn("diameter")
		nameAzimuth		= dataset.MapColumn("azimuth")
		nameExtent		= dataset.MapColumn("extent")
		
		result	= dataset.ExecQuery("SELECT * FROM %s WHERE %s = \"%s\" AND %s = %d" % (
					nameStem, nameSiteid, siteId, nameStemid, stemId))
		row		= result.NextRowD()
		
		if not row:
			return None
			
		stem = Tree()
		if row[nameStemid]:		stem.id 			= int(row[nameStemid])
		if row[nameSiteid]:		stem.site			= row[nameSiteid]
		if row[nameHeight]:		stem.height			= float(row[nameHeight])
		if row[nameDbh]:		stem.diameter		= float(row[nameDbh])
		if row[nameLivestatus]:	stem.alive			= (row[nameLivestatus].lower() == "l")
		if row[nameBranchdata]:	stem.hasBranchData	= (row[nameBranchdata] == "1" or 
			row[nameBranchdata] == True)
		
		result = dataset.ExecQuery("SELECT * FROM %s WHERE %s = \"%s\" AND %s = %d" % 
				(nameBranch, nameSiteid, siteId, nameStemid, stemId))
				
		while 1:
			row = result.NextRowD()
			
			if not row:
				break
				
			branch = Branch()
			if row[nameBranchid]:	branch.id			= int(row[nameBranchid])
			if row[nameStemid]:		branch.stem			= int(row[nameStemid])
			if row[nameSiteid]:		branch.site			= row[nameSiteid]
			if row[nameHeight]:		branch.height		= float(row[nameHeight])
			if row[nameExtent]:		branch.extent		= float(row[nameExtent])
			if row[nameAzimuth]:	branch.azimuth		= int(row[nameAzimuth])
			if row[nameDiameter]:	branch.diameter		= float(row[nameDiameter])
			if row[nameLivestatus]:	branch.alive		= (row[nameLivestatus].lower() == "l")
			
			stem.branches.append(branch)
		
		return stem
		
	def GetInverseColor(self, color):
		"Internal method. Get an inverse of an RGB color"
		
		return (abs(color[0]-255), abs(color[1]-255), abs(color[2]-255))
	
	def Info(self):
		"Plugin information."
		
		info = {
			'name'			: "Silhouette Views",
			'description'	: "Generates 2D images representing the view of a tree from several different angles by connecting branches within 1m.",
			'unit_label'	: "Stem",
			'views'			: 4
		}
		
		return info
		
	def RequiredType(self):
		"Returns 'sql', 'flat', or None depending on required dataset type."
		
		return 'sql'
		
	def RequiredTables(self):
		"Returns a list of required tables, or None if expecting a table-less dataset."
		
		return ["stem", "branch"]
		
	def RequiredColumns(self):
		"Returns a list of required columns in the form [(table, column), ...]"
		
		return [("stem", "site_id"), ("stem", "stem_id"), ("stem", "dbh"), ("stem", "live_status"),
				("stem", "height"), ("stem", "branch_data?"), ("branch", "site_id"), ("branch", 
				"branch_id"), ("branch", "stem_id"), ("branch", "live_status"), ("branch",
				"height"), ("branch", "diameter"), ("branch", "azimuth"), ("branch", "extent")]
		
	def ValidData(self, dataset):
		"Returns True if the provided dataset contains the data necessary to generate this visualization. False otherwise."
		
		#Check data type
		if dataset.GetType() != 'sql':
			return False
		
		#Check Tables
		if not dataset.HasTable("stem", True):
			return False
			
		if not dataset.HasTable("branch", True):
			return False
		
		#Stem Table
		if not dataset.HasColumn("stem", "site_id", True):
			return False
			
		if not dataset.HasColumn("stem", "stem_id", True):
			return False
			
		if not dataset.HasColumn("stem", "dbh", True):
			return False
			
		if not dataset.HasColumn("stem", "live_status", True):
			return False
			
		if not dataset.HasColumn("stem", "height", True):
			return False
			
		if not dataset.HasColumn("stem", "branch_data?", True):
			return False
			
		#Branch Table
		if not dataset.HasColumn("branch", "site_id", True):
			return False
			
		if not dataset.HasColumn("branch", "branch_id", True):
			return False
			
		if not dataset.HasColumn("branch", "stem_id", True):
			return False
			
		if not dataset.HasColumn("branch", "live_status", True):
			return False
			
		if not dataset.HasColumn("branch", "height", True):
			return False
			
		if not dataset.HasColumn("branch", "diameter", True):
			return False
			
		if not dataset.HasColumn("branch", "azimuth", True):
			return False
			
		if not dataset.HasColumn("branch", "extent", True):
			return False
			
		#All There?
		return True
		
	def GetUnits(self, dataset):
		"Returns a list of stems that can be visualized given the available data."
		
		table	= dataset.GetTable("stem")
		units	= [ ]
		
		while 1:
			stem = table.NextRowD()
			
			if stem == None:
				break
				
			if stem['live_status'] == "L" and stem['branch_data?'] == 1:
				try:
					units.append([(stem['site_id'], int(stem['stem_id'])), str(stem['site_id']) + " " + str(stem['stem_id'])])
				except ValueError:
					pass
					
		return units
				
	def GetOptions(self, dataset):
		"Returns a list of options to be provided to the end user at run time."
		
		viewStyle = RadioButtonsOption('view_style', "View Style", ["Show All Branches", "Limit Branches to Angle"], 1)
		
		options = [
			CheckboxOption('grid', "Show Grid", True),
			CheckboxOption('rulers', "Show Rulers", False),
			CheckboxOption('info', "Show Tree Information", True),
			CheckboxOption('direction', "Show Direction", True),
			CheckboxOption('compass', "Show Compass", False),
			CheckboxOption('hide_center', "Hide Center Line", False),
			CheckboxOption('structure', "Show Structure", True),
			CheckboxOption('branches', "Show Branches", True),
			CheckboxOption('dead', "Show Dead Branches", False),
			SpacerOption(),
			RadioButtonsOption('perspective', "Perspective", ["Perspective View", "Full Extent View"], 0),
			SpacerOption(),
			viewStyle,
			NumberOption('angle', "Degrees off center:", 45, viewStyle),
			SpacerOption(),
			ColorOption('bg_color', "Background Color", (255,255,255)),
			ColorOption('label_color', "Label Background Color", (0,0,0))
		]
				
		return options
	
	def GetUnitName(self, dataset, options, id, view=0):
		"Returns a filename for the given unit id and view with current dataset and options."
		
		side = "??"
		
		if view == 0:
			side = "N"
		elif view == 1:
			side = "E"
		elif view == 2:
			side = "SE"
		elif view == 3:
			side = "NE"
		
		return "Tree %d (%s) %s" % (id[1], id[0], side)
	
	def GetImage(self, dataset, options, id, view=0):
		"Returns an OmniImage instance representing the requested stem and view number."
				
		tree = self.GetStem(dataset, id[0], id[1])
		
		if not tree:
			return
		
		#Certain options require more canvas space
		offset = [0,0]
		
		if options['rulers']:
			offset[0] += 50
			
		if options['info']:
			offset[1] += 30
		
		if options['direction']:
			offset[1] += 30
			
		#Create the image
		image = OmniImage((kBaseImageSize[0]+offset[0], kBaseImageSize[1]+offset[1]), options['bg_color'])
		
		#Drawing: Step 1: Grid
		if options['grid']:
			#Horizontal Lines
			for i in range(0, int(kBaseImageSize[1]/kCellSize)+1):
				y = kBaseImageSize[1] - (i*kCellSize)
				image.Draw(OI_Line((0 + offset[0], y), (kBaseImageSize[0] + offset[0], y), 1, self.GetInverseColor(options['bg_color'])))
				
			#Vertical Lines
			vLinesRange = range(0, int(kBaseImageSize[0]/kCellSize)+1)
			for i in vLinesRange:
				if not options['hide_center'] or len(vLinesRange)%2 == 0 or i != int(len(vLinesRange)/2):
					x = offset[0] + (i*kCellSize)
					image.Draw(OI_Line((x, 0), (x, kBaseImageSize[1]), 1, self.GetInverseColor(options['bg_color'])))
					
		#Drawing: Step 2: Rulers
		if options['rulers']:
			for i in range(1, int(kBaseImageSize[1]/kCellSize)+1):
				y			= kBaseImageSize[1] - (i*kCellSize)
				label		= str(i * kCellSize/kPixelsToMeter) + "m"
				labelSize	= OI_String((0,0), label, 18).GetStringSize()
				corner		= (47 - labelSize[0], y - labelSize[1])
				
				image.Draw(OI_String(corner, label, 18, self.GetInverseColor(options['bg_color'])))
				
		#Drawing: Step 3: Tree Information
		if options['info']:
			#Box
			start	= (offset[0], kBaseImageSize[1] - 30 + offset[1])
			end		= (kBaseImageSize[0] + offset[0], kBaseImageSize[1] + offset[1])
			
			image.Draw(OI_Rectangle(start, end, options['label_color'], line=1))
			
			#Label
			label		= "Tree %s (%s)" % (tree.id, tree.site)
			labelSize	= OI_String((0,0), label, 18).GetStringSize()
			corner		= (int(kBaseImageSize[0]/2 - labelSize[0]/2 + offset[0]), int(kBaseImageSize[1] - 15 - labelSize[1]/2 + offset[1]))
			
			image.Draw(OI_String(corner, label, 18, self.GetInverseColor(options['label_color'])))
		
		#Drawing: Side-Specific Steps
		midPoint = kBaseImageSize[0]/2 + offset[0]
		
		#Drawing: Step 4: Direction Label
		if options['direction']:
			#Box
			start	= (offset[0], kBaseImageSize[1])
			end		= (kBaseImageSize[0]+offset[0], kBaseImageSize[1]+30)
			
			image.Draw(OI_Rectangle(start, end, options['label_color'], line=1))
			
			#Label
			label		= kLabelsTable[view]
			labelSize	= OI_String((0,0), label, 18).GetStringSize()
			corner		= (int(kBaseImageSize[0]/2 - labelSize[0]/2 + offset[0]), int(kBaseImageSize[1] + 15 - labelSize[1]/2))
			
			image.Draw(OI_String(corner, label, 18, self.GetInverseColor(options['label_color'])))
			
		#Drawing: Step 5: Sort and Filter Branches
		leftBranches	= [ ]
		rightBranches	= [ ]
		
		left	= Angle(kSideAzimuths[view][0])
		right	= Angle(kSideAzimuths[view][1])
		
		for branch in tree.branches:
			#Filter
			if options['dead'] or branch.alive:
				#Assign to left side
				if left.diff(branch.azimuth) < right.diff(branch.azimuth) and (options['view_style'] == 0 or left.diff(branch.azimuth) < options['angle']):
					#Adjust for perspective
					if options['perspective'] == 0:
						extent = branch.extent * math.cos(math.radians(left.diff(branch.azimuth)))
						
						if extent * kPixelsToMeter >= kMinBranchLength:
							branch = [branch.height * kPixelsToMeter, extent * kPixelsToMeter, branch.alive]
							leftBranches.append(branch)
					
					else:
						if left.diff(branch.azimuth) <= 90:
							branch = [branch.height * kPixelsToMeter, branch.extent * kPixelsToMeter, branch.alive]
							leftBranches.append(branch)
							
				#Assign to right side
				elif right.diff(branch.azimuth) < left.diff(branch.azimuth) and (options['view_style'] == 0 or right.diff(branch.azimuth) < options['angle']):
					#Adjust for perspective
					if options['perspective'] == 0:
						extent = branch.extent * math.cos(math.radians(right.diff(branch.azimuth)))
						
						if extent * kPixelsToMeter >= kMinBranchLength:
							branch = [branch.height * kPixelsToMeter, extent * kPixelsToMeter, branch.alive]
							rightBranches.append(branch)
					
					else:
						if right.diff(branch.azimuth) <= 90:
							branch = [branch.height * kPixelsToMeter, branch.extent * kPixelsToMeter, branch.alive]
							rightBranches.append(branch)
							
				#Sort
				leftBranches	= sorted(leftBranches, lambda x, y: cmp(x[0], y[0]), reverse=True)
				rightBranches	= sorted(rightBranches, lambda x, y: cmp(x[0], y[0]), reverse=True)
				
		#Drawing: Step 6: Canopy Structure
		if options['structure']:
			#Draw Left
			branches = filter(lambda x: x[2], leftBranches) #Filter out dead branches
			
			for i in range(len(branches)):
				if i < len(branches)-1 and (branches[i][0] - branches[i+1][0]) <= kMaxDistance:
					y		= (kBaseImageSize[1] - branches[i][0], kBaseImageSize[1] - branches[i+1][0])
					polygon	= [(midPoint, y[0]), (midPoint - branches[i][1], y[0]), (midPoint - branches[i+1][1], y[1]), (midPoint, y[1])]
					
					image.Draw(OI_Polygon(polygon, (67,144,8)))
					
			#Draw Right
			branches = filter(lambda x: x[2], rightBranches) #Filter out dead branches
			
			for i in range(len(branches)):
				if i < len(branches)-1 and (branches[i][0] - branches[i+1][0]) <= kMaxDistance:
					y		= (kBaseImageSize[1] - branches[i][0], kBaseImageSize[1] - branches[i+1][0])
					polygon	= [(midPoint, y[0]), (midPoint + branches[i][1], y[0]), (midPoint + branches[i+1][1], y[1]), (midPoint, y[1])]
					
					image.Draw(OI_Polygon(polygon, (67,144,8)))
		
		#Drawing: Step 7: Individual & Dead Branches
		if options['branches']:
			#Left
			for branch in leftBranches:
				 y = kBaseImageSize[1] - branch[0]
				 
				 if branch[2]:
				 	fill = (0,0,0)
				 else:
				 	fill = (255,0,0)
				 	
				 image.Draw(OI_Line((midPoint, y), (midPoint - branch[1], y), 1, fill))
				 
			#Right
			for branch in rightBranches:
				 y = kBaseImageSize[1] - branch[0]
				 
				 if branch[2]:
				 	fill = (0,0,0)
				 else:
				 	fill = (255,0,0)
				 	
				 image.Draw(OI_Line((midPoint, y), (midPoint + branch[1], y), 1, fill))
				 
		#Drawing: Step 8: The Trunk
		baseRadius	= tree.diameter / 100 / 2 * kPixelsToMeter
		treeHeight	= tree.height * kPixelsToMeter
		
		trunkPoly = [(midPoint - baseRadius, kBaseImageSize[1]), (midPoint + baseRadius, kBaseImageSize[1]), (midPoint + 1, kBaseImageSize[1] - treeHeight), (midPoint - 1, kBaseImageSize[1] - treeHeight)]
		image.Draw(OI_Polygon(trunkPoly, (182, 61, 54)))
		
		#Drawing: Step 9: Draw Compass
		if options['compass']:
			if view == kSideNorth:
				image.Draw(OI_Bitmap(self.compassNorth, (kBaseImageSize[0]+offset[0]-kCompassSize[0]-25, 20)))

			elif view == kSideEast:
				image.Draw(OI_Bitmap(self.compassEast, (kBaseImageSize[0]+offset[0]-kCompassSize[0]-25, 20)))
				
			elif view == kSideSouthEast:
				image.Draw(OI_Bitmap(self.compassSouthEast, (kBaseImageSize[0]+offset[0]-kCompassSize[0]-25, 20)))
			
			elif view == kSideNorthEast:
				image.Draw(OI_Bitmap(self.compassNorthEast, (kBaseImageSize[0]+offset[0]-kCompassSize[0]-25, 20)))
		
		return image
		
class Tree:
	"Tree struct."
	
	def __init__(self):
		"Constructor."
		
		self.id				= 0
		self.site			= ""
		self.plot			= 0
		self.species		= ""
		self.height			= 0.0
		self.diameter		= 0.0
		self.radii			= {'north' : 0.0, 'east' : 0.0, 'south' : 0.0, 'west' : 0.0}
		self.alive			= False
		self.location		= {'x' : 0.0, 'y' : 0.0, 'z' : 0.0}
		self.hasBranchData	= False
		self.comments		= ""
		self.branches		= [ ]
		
class Branch:
	"Branch struct."
	
	def __init__(self):
		"Constructor."
		
		self.id				= 0
		self.stem			= 0
		self.site			= ""
		self.height			= 0.0
		self.extent			= 0.0
		self.azimuth		= 0
		self.diameter		= 0.0
		self.alive			= False
		self.percentCover	= 0
	
class Angle:
	def __init__(self, angle=0):
		self.multiplier = 0
		self.angle = 0
		
		if isinstance(angle, Angle):
			self.multiplier = angle.multiplier
			self.angle = angle.angle
			
		elif type(angle) == int:
			self.angle = angle
			
			if self.angle >= 360 or self.angle < 0:
				result = Angle() + self
				self.multiplier = result.multiplier
				self.angle = result.angle
			
		else:
			raise ValueError("Cannot set Angle to type %s." % (type(angle)))
	
	def getAngle(self):
		"Returns the angle. This value is always positive. Negative angles are indicated by the presense of a negative multiplier."
		return self.angle
		
	def getMultiplier(self):
		"Returns the multipler. For example, Angle(365).getMultipler() returns 1."
		return self.multiplier
		
	def diff(self, other):
		"Returns the shortest distance between two angles; e.g., 5 and 350 returns 15. This ignores multipliers and negative angles and returns an int."
		
		if type(other) == int:
			other = Angle(other)
			
		if not isinstance(other, Angle):
			raise ValueError("Cannot diff Angle and %s." % (type(other)))
		
		if self.angle == other.angle:
			return 0
		
		resultOne = (self - other).int()
		resultTwo = (other - self).int()
		
		if resultOne < resultTwo:
			return resultOne
			
		else:
			return resultTwo
			
	def center(self, other):
		"Finds the center of two angles; e.g., 355 and 5 returns 0. This ignores multipliers and negative angles and returns a Angle instance."
		
		if type(other) == int:
			other = Angle(other)
			
		if not isinstance(other, Angle):
			raise ValueError("Cannot center Angle and %s." % (type(other)))
			
		if self.angle == other.angle:
			return Angle(self.angle)
		
		resultOne = (self - other).int()
		resultTwo = (other - self).int()
		
		if resultOne < resultTwo:
			top = self
			bottom = other
			
		else:
			top = other
			bottom = self
			
		return Angle( (top - int( (top-bottom).int() / 2 )).int() )
	
	def int(self):
		"Short form of getAngle()."
		return self.angle
		
	def __str__(self):
		return "%d x %d" % (self.multiplier, self.angle)
		
	def __repr__(self):
		return self.__str__()
		
	def __cmp__(self, other):
		if type(other) == int:
			other = Angle(other)
			
		if not isinstance(other, Angle):
			raise ValueError("Cannot compare Angle and %s." % (type(other)))
			
		return (self.multiplier * 360 + self.angle).__cmp__(other.multiplier * 360 + other.angle)
		
	def __add__(self, other):
		if isinstance(other, Angle):
			new = Angle()
			
			new.angle = self.angle + other.angle
			new.multiplier = self.multiplier + other.multiplier

			if new.angle >= 360:
				multiplier = int(new.angle/360)
				new.angle -= 360 * multiplier
				new.multiplier += multiplier
				
			elif new.angle < 0:
				multiplier = int(new.angle/360)
				new.angle += abs(360 * multiplier)
				new.multiplier += multiplier
				
			return new
			
		elif type(other) == int:
			return self.__add__(Angle(other))
			
		else:
			raise ValueError("Cannot add Angle and %s." % (type(other)))
		
	def __radd__(self, other):
		return self.__add__(other)
		
	def __sub__(self, other):
		if isinstance(other, Angle):
			other = Angle(other.multiplier * 360 + other.angle)
			other.multiplier *= -1
			other.angle *= -1
			
		elif type(other) == int:
			other *= -1
			
		else:
			raise ValueError("Cannot subtract Angle and %s." % (type(other)))
			
		return self.__add__(other)
		
	def __rsub__(self, other):
		if isinstance(other, Angle):
			return other.__sub__(self)
			
		elif type(other) == int:
			new = Angle(other)
			return new.__sub__(self)
			
		else:
			raise ValueError("Cannot subtract Angle and %s." % (type(other)))